#ifndef __COPYCODE_H__
#define __COPYCODE_H__

#include <memory.h>

void BitBlt(unsigned char* dstp, int dst_pitch, const unsigned char* srcp, int src_pitch, int row_size, int height, bool isse);
void asm_BitBlt_ISSE(unsigned char* dstp, int dst_pitch, const unsigned char* srcp, int src_pitch, int row_size, int height);
void * memcpy_amd(void *dest, const void *src, size_t n);
void MemZoneSet(unsigned char *ptr, unsigned char value, int width,
				int height, int offsetX, int offsetY, int pitch);
void MoveBlock8_mmx(unsigned char *pDst, int dstPitch,
                    const unsigned char *pSrc, int srcPitch);


typedef void (COPYFunction)(unsigned char *pDst, int nDstPitch,
                            const unsigned char *pSrc, int nSrcPitch);

static void Copy8_c(unsigned char *pDst, int nDstPitch,
                    const unsigned char *pSrc, int nSrcPitch)
{
   for ( int j = 0; j < 8; j++ )
   {
      for ( int i = 0; i < 8; i++ )
         memcpy(pDst, pSrc, 8);
      pDst += nDstPitch;
      pSrc += nSrcPitch;
   }
}
static void Copy4_c(unsigned char *pDst, int nDstPitch,
                    const unsigned char *pSrc, int nSrcPitch)
{
   for ( int j = 0; j < 4; j++ )
   {
      for ( int i = 0; i < 4; i++ )
         memcpy(pDst, pSrc, 4);
      pDst += nDstPitch;
      pSrc += nSrcPitch;
   }
}
static void Copy2_c(unsigned char *pDst, int nDstPitch,
                    const unsigned char *pSrc, int nSrcPitch)
{
   for ( int j = 0; j < 2; j++ )
   {
      for ( int i = 0; i < 2; i++ )
         memcpy(pDst, pSrc, 2);
      pDst += nDstPitch;
      pSrc += nSrcPitch;
   }
}

extern "C" void __cdecl Copy8_mmx(unsigned char *pDst, int nDstPitch,
                                  const unsigned char *pSrc, int nSrcPitch);

extern "C" void __cdecl Copy4_mmx(unsigned char *pDst, int nDstPitch,
                                  const unsigned char *pSrc, int nSrcPitch);

extern "C" void __cdecl Copy2_mmx(unsigned char *pDst, int nDstPitch,
                                  const unsigned char *pSrc, int nSrcPitch);




#endif