;/****************************************************************************
; * $Id$
; *
; ***************************************************************************/

BITS 32

%macro cglobal 1
	%ifdef PREFIX
		global _%1
		%define %1 _%1
	%else
		global %1
	%endif
%endmacro

;=============================================================================
; Read only data
;=============================================================================

SECTION .rodata data align=16

;=============================================================================
; Macros
;=============================================================================

;=============================================================================
; Code
;=============================================================================

SECTION .text

cglobal Copy8_mmx
cglobal Copy4_mmx
cglobal Copy2_mmx

;-----------------------------------------------------------------------------
;
; void Copy8_mmx(unsigned char *pDst, int nDstPitch,
;				 const unsigned char *pSrc, int nSrcPitch);
;
;-----------------------------------------------------------------------------

ALIGN 16

Copy8_mmx:
		push edi
		push esi
		
		mov edi, [esp + 12]
		mov esi, [esp + 20]
		mov edx, [esp + 16]
		mov ecx, [esp + 24]
		
        movq mm0, [esi]				; 0 ->
        movq mm1, [esi + ecx]       ; 1 ->
        movq mm2, [esi + 2 * ecx]   ; 2 ->
        movq [edi], mm0             ; 0 <-
        movq mm3, [esi + 4 * ecx]   ; 4 ->
        movq [edi + edx], mm1       ; 1 <-
        movq [edi + 2 * edx], mm2   ; 2 <-
        movq [edi + 4 * edx], mm3   ; 4 <-

        lea esi, [esi + ecx * 2]    ; 2
        lea edi, [edi + edx * 2]    ; 2

        movq mm0, [esi + ecx]       ; 2 + 1 ->
        movq mm1, [esi + 4 * ecx]   ; 2 + 4 ->
        movq [edi + edx], mm0       ; 2 + 1 <-
        movq [edi + 4 * edx], mm1   ; 2 + 4 <-

        lea esi, [esi + ecx]        ; 3
        lea edi, [edi + edx]        ; 3

        movq mm0, [esi + 2 * ecx]   ; 3 + 2 ->
        movq mm1, [esi + 4 * ecx]   ; 3 + 4 ->
        movq [edi + 2 * edx], mm0   ; 3 + 2 <-
        movq [edi + 4 * edx], mm1   ; 3 + 4 <-
        
        pop esi
        pop edi
        
        ret

;-----------------------------------------------------------------------------
;
; void Copy4_mmx(unsigned char *pDst, int nDstPitch,
;				 const unsigned char *pSrc, int nSrcPitch);
;
;-----------------------------------------------------------------------------

ALIGN 16
       
Copy4_mmx:

		push edi
		push esi

		mov edi, [esp + 12]
		mov esi, [esp + 20]
		mov edx, [esp + 16]
		mov ecx, [esp + 24]
		
		mov eax, [esi]
		mov [edi], eax
		mov eax, [esi + ecx]
		mov [edi + edx], eax
		lea esi, [esi + 2 * ecx]
		lea edi, [edi + 2 * edx]
		mov eax, [esi + ecx]
		mov [edi + edx], eax
		movsd
		
		pop esi
		pop edi
		
		ret

;-----------------------------------------------------------------------------
;
; void Copy2_mmx(unsigned char *pDst, int nDstPitch,
;				 const unsigned char *pSrc, int nSrcPitch);
;
;-----------------------------------------------------------------------------
		
ALIGN 16		

Copy2_mmx:

		push edi
		push esi
		
		mov edi, [esp + 12]
		mov esi, [esp + 20]
		
		mov edx, [esp + 16]
		mov ecx, [esp + 24]
		
		movsw
		lea esi, [esi + ecx - 2]
		lea edi, [edi + edx - 2]
		movsw
		
		pop esi
		pop edi
		
		ret
		

		
