#ifndef __CORRECTOR__
#define __CORRECTOR__

#include "avisynth.h"
#include "portability.h"

void ProcessMean(Uint8 *pDst, const Uint8 *pSrc, const Uint8 **pSrcs,
                  int nDstPitch, int nSrcPitch, int *pPitches, int width, int height, int nThreshold, int nClips);
void ProcessBest(Uint8 *pDst, const Uint8 *pSrc, const Uint8 **pSrcs,
                  int nDstPitch, int nSrcPitch, int *pPitches, int width, int height, int nThreshold, int nClips);


class Corrector : public GenericVideoFilter {
private:
   const PClip *mvclips;
   int nWidth;
   int nHeight;
   int nThreshold;
   int nClips;

public:
	Corrector(PClip _child, PClip *clps, int nbclp, int mode, int th, IScriptEnvironment* env);
   ~Corrector();

   void (* Process)(Uint8 *pDst, const Uint8 *pSrc, const Uint8 **pSrcs,
                    int nDstPitch, int nSrcPitch, int *pPitches, int width, int height, int th, int nclips);


	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif