// Define the BlockData class

// I borrowed a lot of code from XviD's sources here, so I thank all the developpers
// of this wonderful codec

// See legal notice in Copying.txt for more information

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#ifndef __FAKEBLOCKDATA__
#define __FAKEBLOCKDATA__

#include "portability.h"

class FakeBlockData {
	int x;
	int y;
	VECTOR vector;
	int nSad;
	int nLength;
   int nVariance;
   int nLuma;
   int nRefLuma;
   int nPitch;

   const unsigned char *pRef;

	MOTION_INLINE static int SquareLength(const VECTOR& v)
	{ return v.x * v.x + v.y * v.y; }

public : 
	FakeBlockData(int _x, int _y);
	~FakeBlockData();

	void Update(const int *array, const unsigned char *ref, int pitch);

	MOTION_INLINE int GetX() const { return x; }
	MOTION_INLINE int GetY() const { return y; }
	MOTION_INLINE VECTOR GetMV() const { return vector; }
	MOTION_INLINE int GetSAD() const { return nSad; }
	MOTION_INLINE int GetMVLength() const { return nLength; }
   MOTION_INLINE int GetVariance() const { return nVariance; }
   MOTION_INLINE int GetLuma() const { return nLuma; }
   MOTION_INLINE int GetRefLuma() const { return nRefLuma; }
   MOTION_INLINE const unsigned char *GetRef() const { return pRef; }
   MOTION_INLINE int GetPitch() const { return nPitch; }
};

#endif