#include "FakeGroupOfPlanes.h"

FakeGroupOfPlanes::FakeGroupOfPlanes(int w, int h, int size, int lv, int pel)
{
   nLvCount = lv;
   nWidth = w;
   nHeight = h;

   planes = new FakePlaneOfBlocks*[nLvCount];
   planes[0] = new FakePlaneOfBlocks(w, h, size, 0, pel);
	for (int i = 1; i < nLvCount; i++ )
		planes[i] = new FakePlaneOfBlocks(w >> i, h >> i, size, i, 1);
}

FakeGroupOfPlanes::~FakeGroupOfPlanes()
{
   for ( int i = 0; i < nLvCount; i++ )
		delete planes[i];
	delete[] planes;
}

void FakeGroupOfPlanes::Update(const int *array)
{
   const int *pA = array;
	validity = GetValidity(array);

   pA += 2;
	for ( int i = nLvCount - 1; i >= 0; i-- )
		pA += pA[0];

   pA++;

   compensatedPlane = reinterpret_cast<const unsigned char *>(pA);
   compensatedPlaneU = compensatedPlane + nWidth * nHeight;
   compensatedPlaneV = compensatedPlane + nWidth * nHeight * 5 / 4;

   pA = array;
   pA += 2;
	for ( int i = nLvCount - 1; i >= 0; i-- )
	{
      planes[i]->Update(pA + 1, compensatedPlane, nWidth);
		pA += pA[0];
	}
}

bool FakeGroupOfPlanes::IsSceneChange(int nThSCD1, int nThSCD2) const
{
	return planes[0]->IsSceneChange(nThSCD1, nThSCD2);
}
