
// Change the number of frames of the clip without changing its speed

// See legal notice in Copying.txt for more information

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#ifndef __MV_BIDOUILLE__
#define __MV_BIDOUILLE__

#include "GenericMotionFilter.h"
#include "MVFrame.h"

typedef struct {
   unsigned char nValue;
   unsigned int nSad;

} Pixels;

class MVBidouille : public GenericMotionFilter {
   FakeGroupOfPlanes *fgopFW;
	FakeGroupOfPlanes *fgopBW;
	PClip mvclipBW;
	PClip mvclipFW;

   MVFrames *pFrames;

   int nOBMCMargin;

   int nExtendedWidth;
   int nExtendedHeight;
   int nExtendedPitch;

   int nOffset;
   int nOffsetUV;

   int nIdx;

   int **pBlkSadModifier;
   int nBlkSadPitch;

   Pixels **pFinalDst;
   Pixels **pFinalDstU;
   Pixels **pFinalDstV;

protected:
   void MoveBlock(MVFrame *pFrame, const FakeBlockData& block, int nRatio, int nIdx);
   void CollectResults(unsigned char *pDst, int nDstPitch, int width, int height);


public:
	MVBidouille(PClip _child, PClip mvsbw, PClip mvsfw, int _nIdx, const MotionParameters &params, IScriptEnvironment* env);
	~MVBidouille();
   PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif