#ifndef __MV_COMPENSATE__
#define __MV_COMPENSATE__


#include "GenericMotionFilter.h"


/*! \brief Filter that denoise the picture
 */
class MVCompensate : public GenericMotionFilter {
private:

	FakeGroupOfPlanes *fgop;
	PClip mvclip;
    bool scBehavior;
    bool inLoop;
    bool inClip;
    unsigned char **pRefs;
    unsigned char **pRefsU;
    unsigned char **pRefsV;
    int nRefPitch;
    int nRefHeight;
    int nRefWidth;
    int nRefPitchUV;
    int nRefWidthUV;
    int nRefHeightUV;
    int nOffset;
    int nOffsetUV;

    void MoveBlock(unsigned char *pDst, int nDstPitch, int x, int y, int mvx, int mvy);
    void MoveBlockU(unsigned char *pDst, int nDstPitch, int x, int y, int mvx, int mvy);
    void MoveBlockV(unsigned char *pDst, int nDstPitch, int x, int y, int mvx, int mvy);
 
public:
	MVCompensate(PClip _child, PClip vectors, bool sc, bool inclip, bool inloop,
                 const MotionParameters &params, IScriptEnvironment* env);
	~MVCompensate();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};

#endif