#include "MVCore.h"

#ifdef MOTION_PROFILE
int ProfTimeTable[MOTION_PROFILE_COUNT];
int ProfResults[MOTION_PROFILE_COUNT * 2];
__int64 ProfCumulatedResults[MOTION_PROFILE_COUNT * 2];
#endif

MVCore MVCore::mvCore;

MVCore::MVCore()
{
   pFramesList = new MVFramesList();
   nAutoIdx = 0;

   DebugPrintf("Creation of mvCore\n");

   PROFILE_INIT();
}

MVCore::~MVCore()
{
   if (pFramesList)
      delete pFramesList;

   DebugPrintf("Destruction of mvCore");

   PROFILE_SHOW();
}

void MVCore::AddFrames(int nIdx, int nNbFrames, int nLevelCount, int nWidth,
                       int nHeight, int nPel, int nHPad, int nVPad, int nMode, bool isse)
{
   DebugPrintf("Add frames list, with %i as idx\n", nIdx);
   if ( !pFramesList->GetFrames(nIdx) )
   {
      DebugPrintf("Idx not found, creating a new list of frames...\n");
      pFramesList = new MVFramesList(pFramesList, nIdx, nNbFrames, nLevelCount, nWidth,
                                     nHeight, nPel, nHPad, nVPad, nMode, isse);
   }
   else
   {
      DebugPrintf("Idx already found, no need to add a list of frames\n");
   }
}

MVFrames *MVCore::GetFrames(int nIdx)
{
   return pFramesList->GetFrames(nIdx);
}
