#ifndef __Q_DEQUANT__
#define __Q_DEQUANT__

#include "avisynth.h"

class QDeQuant : public GenericVideoFilter {
private:
    bool mmx, isse;
    int width, height;
    int quant;
    int level;
    int deadzone;
    

    void QDQPicture(unsigned char *dstp, const unsigned char *srcp, int dstPitch, int srcPitch,
                    int w, int h, int q, int lv, int dz);
    void QDQBlock(int *dstp, int q, int f);
    void IITsf(unsigned char *dstp, const int *srcp, int dstPitch, int lv);
    void IITsf2(unsigned char *dstp, const int *srcp, int dstPitch, int lv);
    void FITsf(int *dstp, const unsigned char *srcp, int srcPitch, int lv);
    inline int sat(int x, int min, int max)
    { return (x < min) ? min : ((x > max) ? max : x); }


public:
	QDeQuant(PClip _child, int q, int lev, int qz, bool _mmx, bool _isse, IScriptEnvironment* env);
    ~QDeQuant();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};



#endif
