#ifndef __Q_DENOISE__
#define __Q_DENOISE__

#include "avisynth.h"

class QDenoise : public GenericVideoFilter {
private:
    bool mmx, isse;
    int width, height;
    int quant;
    

    void QDQPicture(unsigned char *dstp, const unsigned char *srcp, const int dstPitch, const int srcPitch,
                    const int w, const int h);
    void QDQBlock(int *dstp, int q, int f);
    void IITsf(unsigned char *dstp, const int *srcp, const int dstPitch);
    void FITsf(int *dstp, const unsigned char *srcp, const int srcPitch);
    inline int sat(int x, int min, int max)
    { return (x < min) ? min : ((x > max) ? max : x); }


public:
	QDenoise(PClip _child, int q, bool _mmx, bool _isse, IScriptEnvironment* env);
    ~QDenoise();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
};



#endif
