;/****************************************************************************
; * $Id$
; *
; ***************************************************************************/

BITS 32

%macro cglobal 1
	%ifdef PREFIX
		global _%1
		%define %1 _%1
	%else
		global %1
	%endif
%endmacro

;=============================================================================
; Read only data
;=============================================================================

SECTION .rodata data align=16

ALIGN 16
mmx_one:
	times 4	dw 1
	
;=============================================================================
; Macros
;=============================================================================


;=============================================================================
; Code
;=============================================================================

SECTION .text

cglobal SAD4x4_iSSE

;-----------------------------------------------------------------------------
;
; unsigned int SAD4x4_iSSE(const unsigned char * cur,
;						   const unsigned char * ref,
;						   const unsigned int cpitch,
;						   const unsigned int rpitch);
;
;-----------------------------------------------------------------------------

ALIGN 16
SAD4x4_iSSE:
	push ebx
	
	;pxor mm0, mm0
	;pxor mm1, mm1
	
    mov eax, [esp+4+ 4]		; cur
    mov ebx, [esp+4+ 8]		; ref
    mov ecx, [esp+4+12]		; cpitch
    mov edx, [esp+4+16]		; dpitch
    
    ;pxor mm2, mm2
    ;pxor mm3, mm3
    
    push esi
    push edi
    
    lea	esi, [ecx+2*ecx]    ; 3*cpitch
    lea edi, [edx+2*edx]	; 3*dpitch
 
	movd   mm0, [eax]		;0
	movd   mm2, [ebx]
	movd   mm1, [eax+ecx]   ;1
	movd   mm3, [ebx+edx]

	;pxor   mm4, mm4
	;pxor   mm5, mm5
	;pxor   mm6, mm6
	;pxor   mm7, mm7

	psadbw mm0, mm2			;0
	psadbw mm1, mm3			;1

	movd   mm4, [eax+2*ecx]	;2
	movd   mm5, [ebx+2*edx]
	movd   mm6, [eax+esi]	;3
	movd   mm7, [ebx+edi]

	psadbw mm4, mm5			;2
	psadbw mm6, mm7			;3

	paddd  mm0, mm1
	paddd  mm4, mm6

	pop edi
	pop esi
	pop ebx

	paddd  mm0, mm4
	movd   eax, mm0
	
	ret