#include "Variance.h"

#define ABS(x) (((x) < 0) ? -(x) : (x))

unsigned int Var8x8_C(const unsigned char *pSrc, int nSrcPitch, int *pLuma)
{
   const unsigned char *s = pSrc;
   int meanLuma = 0;
   int meanVariance = 0;
   for ( int j = 0; j < 8; j++ )
   {
      for ( int i = 0; i < 8; i++ )
         meanLuma += s[i];
      s += nSrcPitch;
   }
   *pLuma = meanLuma;
   meanLuma = (meanLuma + 32) / 64;
   s = pSrc;
   for ( int j = 0; j < 8; j++ )
   {
      for ( int i = 0; i < 8; i++ )
         meanVariance += ABS(s[i] - meanLuma);
      s += nSrcPitch;
   }
   return meanVariance;
}

unsigned int Var4x4_C(const unsigned char *pSrc, int nSrcPitch, int *pLuma)
{
   const unsigned char *s = pSrc;
   int meanLuma = 0;
   int meanVariance = 0;

   for ( int j = 0; j < 4; j++ )
   {
      for ( int i = 0; i < 4; i++ )
         meanLuma += s[i];
      s += nSrcPitch;
   }

   *pLuma = meanLuma;

   meanLuma = (meanLuma + 8) / 16;

   s = pSrc;

   for ( int j = 0; j < 4; j++ )
   {
      for ( int i = 0; i < 4; i++ )
         meanVariance += ABS(s[i] - meanLuma);
      s += nSrcPitch;
   }

   return meanVariance;
}

unsigned int Luma8x8_C(const unsigned char *pSrc, int nSrcPitch)
{
   const unsigned char *s = pSrc;
   int meanLuma = 0;
   for ( int j = 0; j < 8; j++ )
   {
      for ( int i = 0; i < 8; i++ )
         meanLuma += s[i];
      s += nSrcPitch;
   }
   return meanLuma;
}

unsigned int Luma4x4_C(const unsigned char *pSrc, int nSrcPitch)
{
   const unsigned char *s = pSrc;
   int meanLuma = 0;
   for ( int j = 0; j < 4; j++ )
   {
      for ( int i = 0; i < 4; i++ )
         meanLuma += s[i];
      s += nSrcPitch;
   }
   return meanLuma;
}